
#include "gc_strings.h"
#include "wx/intl.h"

const wxString gcerr::abandonExport          = "internal message -- abandoning export. if you're reading this, there's an error.";
const wxString gcerr::badEffectivePopSize    = wxTRANSLATE("Couldn't set effective population size for region \"%s\" to %f. The value must be positive.");
const wxString gcerr::badHapFile    = wxTRANSLATE("Failed to read hap file \"%s\" because of the following error:\n%s\nIgnoring.");
const wxString gcerr::badMapFile    = wxTRANSLATE("Failed to read map file \"%s\" because of the following error:\n%s\nIgnoring.");
// const wxString gcerr::badSamplesPer = wxTRANSLATE("Couldn't set samples per individual for %s to %d. The value must be positive");
const wxString gcerr::badSequentialDataCast = wxTRANSLATE("GCSequentialData wasn't allelic when it should have been guaranteed to be so.");
const wxString gcerr::corruptedDisplayableLociInMapOrder= wxTRANSLATE("map order of displayable segments incorrectly calculated");
const wxString gcerr::duplicateLocusInRegion= wxTRANSLATE("Segment \"%s\" added to region \"%s\" twice.");
const wxString gcerr::duplicateMapPosition= wxTRANSLATE("More than one segment of region \"%s\" has map position %ld");
const wxString gcerr::emptyGroupName    =   wxTRANSLATE("Empty region name not allowed. Ignoring your command.");
const wxString gcerr::emptyLocusName    =   wxTRANSLATE("Empty segment name not allowed. Ignoring your command.");
const wxString gcerr::emptyPopulationName = wxTRANSLATE("Empty population name not allowed. Ignoring your command.");
const wxString gcerr::emptyName         =   wxTRANSLATE("Empty name for population, region, segment, or trait");
const wxString gcerr::fileWithRow       =   wxTRANSLATE("Near row %d of file %s:\n%s");
const wxString gcerr::fileWithoutRow    =   wxTRANSLATE("In file %s:\n%s");
const wxString gcerr::hapFileIllegalDelimiter   =   wxTRANSLATE("Delimiter \"%s\" illegal -- must be a single character.");
const wxString gcerr::hapFilePositionNegative   =   wxTRANSLATE("In phase information file \"%s\": position %d cannot be negative");
const wxString gcerr::hapFilePositionNotLong    =   wxTRANSLATE("In phase information file \"%s\": position \"%s\" not a long value");
const wxString gcerr::hapFilePositionUnordered  =   wxTRANSLATE("In phase information file \"%s\": position %d comes after later position %d");
const wxString gcerr::hapFileReadErrUnknown     =   wxTRANSLATE("Unknown error occured while reading phase information file \"%s\"");
const wxString gcerr::incompatibleLocusLengths=   wxTRANSLATE("Incompatible segment lengths %d and %d");
const wxString gcerr::incompatibleLocusTypes  =   wxTRANSLATE("Incompatible data types %s and %s");
const wxString gcerr::incompatibleNumHaps=  wxTRANSLATE("Incompatible hap counts %d and %d");
const wxString gcerr::inIndividual      =   wxTRANSLATE("Error writing data for individual \"%s\": %s");
const wxString gcerr::lengthTooShort    =   wxTRANSLATE("Length %d too short for data with %d sites");
const wxString gcerr::locusOverlap  = wxTRANSLATE("Segment \"%s\", ending at position %ld overlaps segment \"%s\" starting at position %ld.");
const wxString gcerr::locusWithoutDataType  = wxTRANSLATE("Segment \"%s\" in region \"%s\" needs data type assignment.");
const wxString gcerr::locusWithoutLength  = wxTRANSLATE("Segment \"%s\" needs data length assignment.");
const wxString gcerr::locusWithoutMapPosition  = wxTRANSLATE("Segment \"%s\" needs map position assignment.");
const wxString gcerr::missingDataTypeForLocus   = wxTRANSLATE("Segment \"%s\" needs a data type assignment");
const wxString gcerr::missingHapFileId  =   wxTRANSLATE("No hap file with id\"%d\" found");
const wxString gcerr::missingFileId     =   wxTRANSLATE("No file with id\"%d\" found");
const wxString gcerr::missingLengthForLocus   = wxTRANSLATE("Segment \"%s\" needs a total length assignment");
const wxString gcerr::missingParse      =   wxTRANSLATE("Could not find any parse data assigned to file \"%s\"");
const wxString gcerr::missingParseId    =   wxTRANSLATE("No parse with id\"%d\" found");
//const wxString gcerr::missingPhaseDataForLocus=   wxTRANSLATE("Individual \"%s\" is missing phase information for segment \"%s\". Did you write a phase info file?");
const wxString gcerr::missingRegion     =   wxTRANSLATE("Did not find region \"%s\"");
//const wxString gcerr::missingSampleDataForLocus=   wxTRANSLATE("Sample \"%s\" of individual \"%s\" is missing data for segment \"%s\".");
const wxString gcerr::missingTrait      =   wxTRANSLATE("Did not find trait \"%s\"");
const wxString gcerr::mungeParseDataTypeMismatch=   wxTRANSLATE("Tried to munge parses with incompatible data types");
const wxString gcerr::mungeParseFormatMismatch=   wxTRANSLATE("Tried to munge parses with incompatible formats");
const wxString gcerr::mungeParseNeedsTwo=   wxTRANSLATE("Tried to munge other than two parses");
const wxString gcerr::mungeParseNull    =   wxTRANSLATE("Tried to munge null parse");
const wxString gcerr::nameResolutionPairMissing =   wxTRANSLATE("Did not find (population, region) pair (%s,%s) in name resolution");
const wxString gcerr::noBlockForPopLocus=   wxTRANSLATE("Did not find a block for pop %d and segment %d");
const wxString gcerr::noDataFound       =   wxTRANSLATE("Did not find any exportable data. Have you added a data file?");
const wxString gcerr::noSuchParse       =   wxTRANSLATE("Did not find parse of type (%s,%s,%s) for file %s");
const wxString gcerr::notALocation      =   wxTRANSLATE("\"%s\" does not specify a location. It should be a long integer");
const wxString gcerr::provideDoDelete   =   wxTRANSLATE("Subclasses of gcUpdatingDialog must override virtual method ::DoDelete method if they include a button with wxID_DELETE");
const wxString gcerr::regionNoData =   wxTRANSLATE("No data found for region \"%s\".");
const wxString gcerr::regionNoEffectivePopSize =   wxTRANSLATE("Call to GetEffectivePopSize() for region id %d without HasEffectivePopSize()");
const wxString gcerr::regionNoPositionToGet =   wxTRANSLATE("Call to GetPosition() without HasPosition()");
// const wxString gcerr::regionNoSamplesPerIndividual =   wxTRANSLATE("Call to GetSamplesPerIndividual() for region id %d without HasSamplesPerIndividual()");
const wxString gcerr::regionNoSuchLocus =   wxTRANSLATE("Segment with id %d not associated with region id %d");
const wxString gcerr::regionTraitAlreadyAdded=  wxTRANSLATE("Attempt to re-add trait with id %d");
const wxString gcerr::regionNoSuchTrait =   wxTRANSLATE("Trait with id %d not associated with region id %d");
const wxString gcerr::requireCmdFile    =   wxTRANSLATE("Option -c <cmdfile> required for batch (non-gui) converter.");
const wxString gcerr::shortDna          =   wxTRANSLATE("Tried to add bogus nuclear data \"%s\" to sample \"%s\". Is the sample too short or does it have non-dna data?"); 
const wxString gcerr::tooBigDataIndex   =   wxTRANSLATE("Index %d request parse sample larger than actual hap count of %d");
const wxString gcerr::tooFewLociInSpec  =   wxTRANSLATE("Spec for segment doesn't allow segment with index %d");
const wxString gcerr::tooFewPopsInSpec  =   wxTRANSLATE("Spec for populations doesn't allow segment with index %d");
const wxString gcerr::tooManySites      =   wxTRANSLATE("Found more data sites than expected.");
const wxString gcerr::unableToExport    =   wxTRANSLATE("Unable to export file because:%s");
const wxString gcerr::uncaughtException =   wxTRANSLATE("Uncaught Exception:%s");
const wxString gcerr::unsetLength       =   wxTRANSLATE("Call to GetLength() for segment \"%s\" without checking HasLength()");
const wxString gcerr::unsetMapPosition  =   wxTRANSLATE("Call to GetMapPosition() for segment \"%s\" without checking HasMapPosition()");
const wxString gcerr::unsetNumSites     =   wxTRANSLATE("Call to GetNumSites() for segment \"%s\" without checking HasNumSites()");
const wxString gcerr::unsetRegionId     =   wxTRANSLATE("Call to GetRegionId() for segment \"%s\" without checking HasRegionId()");

const wxString gcstr::abandonExport     =   wxTRANSLATE("Abort Export");
const wxString gcstr::addHapFile        =   wxTRANSLATE("Select New Haplotype/Phase Resolution File");
const wxString gcstr::addLocus          =   wxTRANSLATE("Adding New Segment");
const wxString gcstr::addPop            =   wxTRANSLATE("Adding New Population");
const wxString gcstr::addRegion         =   wxTRANSLATE("Adding New Region");
const wxString gcstr::adjacent          =   "adjacent";
const wxString gcstr::all               =   "all";
const wxString gcstr::allele            =   wxTRANSLATE("allele");
const wxString gcstr::allelic           =   "Allelic";
const wxString gcstr::allFiles          =   "*";
const wxString gcstr::assignTabTitle    =   wxTRANSLATE("Data Partitions");

const wxString gcstr::badLocusLength    =   wxTRANSLATE("Attempted to set length of segment \"%s\" to illegal value \"%s\". All lengths must be positive integers. Ignoring.");
const wxString gcstr::badLocusLength1   =   wxTRANSLATE("The following segments have suspiciously short lengths:");
const wxString gcstr::badLocusLength2   =   wxTRANSLATE("You may wish to cancel this operation and edit segment lengths in the Genomic Segments Properties tab");
const wxString gcstr::badLocusPosition  =   wxTRANSLATE("Attempted to set position of segment \"%s\" to illegal value \"%s\". All map positions must be integers. Ignoring.");
const wxString gcstr::badRegionLength1  =   wxTRANSLATE("The following regions have suspiciously short lengths:");
const wxString gcstr::badRegionLength2  =   wxTRANSLATE("You may wish to cancel this operation and edit region lengths in the Genomic Region Properties tab");
const wxString gcstr::batchFileDefault  =   "exported_batch_commands.xml";
const wxString gcstr::batchOutComment   =   wxTRANSLATE("Exported from lamarc converter %s");
const wxString gcstr::batchSafeFinish   =   wxTRANSLATE("batch converter finished successfully");
const wxString gcstr::blockFromFiles    =   wxTRANSLATE("1 block from %d files");
const wxString gcstr::blockInfo1        =   wxTRANSLATE("%d samples of type %s");
const wxString gcstr::blockInfo2        =   wxTRANSLATE("from file %s");
const wxString gcstr::blockFileInfo     =   wxTRANSLATE("data file:");
const wxString gcstr::blockLocusChoice  =   wxTRANSLATE("Choose a segment for this block:");
const wxString gcstr::blockLocusIndexInFile  =   wxTRANSLATE("Locus order within file");
const wxString gcstr::blockPopChoice    =   wxTRANSLATE("Choose a population for this block:");
const wxString gcstr::blockPopIndexInFile  =   wxTRANSLATE("Population order within file");
const wxString gcstr::blockPloidyInfo   =   wxTRANSLATE("%d %s samples\n\nChange sample ploidy in Data File panel.");
const wxString gcstr::blockPloidyTitle  =   wxTRANSLATE("Samples and Sequences");
const wxString gcstr::blocksFromFiles   =   wxTRANSLATE("%d blocks from %d files");
const wxString gcstr::buttonHide        =   wxTRANSLATE("Hide Detail");
const wxString gcstr::buttonSelectAll   =   wxTRANSLATE("Select All");
const wxString gcstr::buttonUnselectAll =   wxTRANSLATE("Unselect All");
const wxString gcstr::buttonShow        =   wxTRANSLATE("Show Detail");
const wxString gcstr::byfile            =   "by file";
const wxString gcstr::byprog            =   "by program";
const wxString gcstr::byuser            =   "by user";
const wxString gcstr::cancelString      =   wxTRANSLATE("Cancel");
const wxString gcstr::chooseHapResolution = wxTRANSLATE("Choose Haplotype Resolution");
const wxString gcstr::chooseOne         =   wxTRANSLATE("Choose one");
const wxString gcstr::chooseOneGroup    =   wxTRANSLATE("Choose one Region");
const wxString gcstr::chooseOneLocus    =   wxTRANSLATE("Choose one Segment");
const wxString gcstr::chooseOneParse    =   wxTRANSLATE("Choose one Parse");
const wxString gcstr::chooseOnePop      =   wxTRANSLATE("Choose one Population");
const wxString gcstr::continueExport    =   wxTRANSLATE("Export Without Locations");
const wxString gcstr::continueString    =   wxTRANSLATE("Export");
const wxString gcstr::cannotWrite       =   wxTRANSLATE("Unable to write file \"%s\"");
const wxString gcstr::chooseDataType    =   wxTRANSLATE("Choose");
const wxString gcstr::chooseFileType    =   wxTRANSLATE("Choose");
const wxString gcstr::converterInfo     =   wxTRANSLATE("A GUI version of the LAMARC converter.\n\nlamarc@gs.washington.edu\n\nhttp://evolution.gs.washington.edu/lamarc/\n\nCopyright 2006 Mary K. Kuhner, Peter Beerli, Joe Felsenstein, Eric Rynes, Lucian Smith, Elizabeth A. Walkup, Jon Yamato");
const wxString gcstr::converterTitle    =   wxTRANSLATE("LAMARC File Converter");
const wxString gcstr::createNewRegion   =   wxTRANSLATE("place in its own region");
const wxString gcstr::dataBlocks        =   wxTRANSLATE("parsed data");
const wxString gcstr::dataFileBatchExport=  wxTRANSLATE("Select data file to write batch commands to");
const wxString gcstr::dataFileButtonAdd =   wxTRANSLATE("Add");
const wxString gcstr::dataFileButtonAllSelect =   wxTRANSLATE("Select All");
const wxString gcstr::dataFileButtonAllUnselect =   wxTRANSLATE("Unselect All");
const wxString gcstr::dataFileButtonRemoveSelected =   wxTRANSLATE("Remove Selected");
const wxString gcstr::dataFileExport    =   wxTRANSLATE("Select data file to write");
const wxString gcstr::dataFiles         =   "Phylip and Migrate files (*.phy;*.mig)|*.phy;*.mig|All Files (*)|*";
const wxString gcstr::dataFilesInstructions   =   wxTRANSLATE("Add a file using the button above.");
const wxString gcstr::dataFilesSelect   =   wxTRANSLATE("Select data files to read");
const wxString gcstr::dataFilesTitle    =   wxTRANSLATE("Information on %d Data Files");
const wxString gcstr::dataType          =   wxTRANSLATE("Data Type");
const wxString gcstr::dna               =   "DNA";
const wxString gcstr::doneThanks        =   wxTRANSLATE("Operation completed.");
const wxString gcstr::editApply         =   wxTRANSLATE("Apply");
const wxString gcstr::editCancel        =   wxTRANSLATE("Cancel");
const wxString gcstr::editDelete        =   wxTRANSLATE("Delete");
const wxString gcstr::editFileSettings  =   wxTRANSLATE("Edit/Review Settings for file \"%s\"");
const wxString gcstr::editLocus         =   wxTRANSLATE("Edit segment \"%s\"");
const wxString gcstr::editOK            =   wxTRANSLATE("OK");
const wxString gcstr::editParseBlock    =   wxTRANSLATE("Edit parsed data properties");
const wxString gcstr::editPop           =   wxTRANSLATE("Edit population \"%s\"");
const wxString gcstr::editRegion        =   wxTRANSLATE("Edit Region \"%s\"");
const wxString gcstr::enterNewName      =   wxTRANSLATE("Enter new name");
const wxString gcstr::error             =   wxTRANSLATE("ERROR");
const wxString gcstr::errorWrap         =   wxTRANSLATE("Error Type \"%s\" for file \"%s\":\n%s");
const wxString gcstr::errorWrapNoFile   =   wxTRANSLATE("Error Type \"%s\":\n%s");
const wxString gcstr::exportFileDefault =   "infile.xml";
const wxString gcstr::exportFileGlob    =   "Lamarc files (*.xml)|*.xml|All files (*)|*";
const wxString gcstr::exportWarning     =   wxTRANSLATE("Warning: export may not be correct");
const wxString gcstr::falseVal          =   wxTRANSLATE("false");
const wxString gcstr::fileAlreadyAdded      =   wxTRANSLATE("Cannot add file \"%s\". It is already added.");
const wxString gcstr::fileDelete            =   wxTRANSLATE("Delete");
const wxString gcstr::fileEmpty             =   wxTRANSLATE("File \"%s\" appears to be empty.");
const wxString gcstr::fileLabelDataType     =   wxTRANSLATE("Data Type");
const wxString gcstr::fileLabelFormat       =   wxTRANSLATE("File Format");
const wxString gcstr::fileLabelInterleaving =   wxTRANSLATE("Sequence Alignment");
const wxString gcstr::fileLabelName         =   wxTRANSLATE("File Name");
const wxString gcstr::fileLabelRemove       =   wxTRANSLATE("Remove File");
//const wxString gcstr::fileLabelUnlinked     =   wxTRANSLATE("Unlink Microsats");
const wxString gcstr::fileSetting           =   wxTRANSLATE("phase grouping set at file level");
const wxString gcstr::firstPositionScanned  =   wxTRANSLATE("First Position Scanned");
const wxString gcstr::fullPath              =   wxTRANSLATE("Full Path to File:");
const wxString gcstr::genoFileDefault   =   wxTRANSLATE("No trait resolution set for this file");
const wxString gcstr::globAll               =   "*";
const wxString gcstr::hapFileEmptyFirstLine =   wxTRANSLATE("No data found in first line of phase information file \"%s\"");
const wxString gcstr::hapFileBarf       =   wxTRANSLATE("Implementation error reading phase information file \"%s\"");
const wxString gcstr::hapFileDefault    =   wxTRANSLATE("Use default haplotype and phase resolution");
const wxString gcstr::hapFileMissing    =   wxTRANSLATE("Phase information file \"%s\" missing or un-readable");
const wxString gcstr::hapFileParseFailed=   wxTRANSLATE("Parse of phase information file \"%s\" failed:%s");
const wxString gcstr::hapFileToken1     =   wxTRANSLATE("First token of phase information file \"%s\" was \"%s\" but expected an integer");
const wxString gcstr::hapFileToken2     =   wxTRANSLATE("Second token of phase information file \"%s\" was \"%s\" but expected \"adjacent\" or end of line");
const wxString gcstr::hapFileToken3     =   wxTRANSLATE("Third token of phase information file \"%s\" was \"%s\" but expected an integer");
const wxString gcstr::hapFileToken3Missing =   wxTRANSLATE("Third token of phase information file \"%s\" missing");
const wxString gcstr::hapFileReuse      =   wxTRANSLATE("Attempt to add phase information file \"%s\" a second time");
const wxString gcstr::hapFileSelect     =   wxTRANSLATE("select phase information file");
const wxString gcstr::hapFileSelectAnother  =   wxTRANSLATE("file not listed here");
const wxString gcstr::hapFileUnSelect   =   wxTRANSLATE("un-select current file");
const wxString gcstr::hapFilesSelect    =   wxTRANSLATE("Select and apply file(s) with haplotype correspondence information.");
const wxString gcstr::havePatience      =   wxTRANSLATE("About to start a lengthy operation. Please wait.");
const wxString gcstr::hiddenContent     =   wxTRANSLATE("IMPLEMENTATION ERROR -- this should be a hidden object");
const wxString gcstr::indent            =   "  ";
const wxString gcstr::information       =   wxTRANSLATE("Information");
const wxString gcstr::instructionsMultipleDataTypes=wxTRANSLATE("The \"datatype\" attribute for the above infile tag should be edited to list only one datatype.");
const wxString gcstr::interleaved       =   wxTRANSLATE("Interleaved");
const wxString gcstr::interleavedNoKalleleMsat  =   wxTRANSLATE("Interleaved format not compatible with Kallele or Microsat data (file \"%s\"");
const wxString gcstr::kallele           =   "Kallele";
const wxString gcstr::linkGCreateTitle  =   wxTRANSLATE("Create a New Region");
const wxString gcstr::linkGEnterNewName=   wxTRANSLATE("Enter the name of the new region");
const wxString gcstr::linkageCaption   =   wxTRANSLATE("Linkage:");
const wxString gcstr::linkageNo        =   wxTRANSLATE("unlinked");
const wxString gcstr::linkageYes       =   wxTRANSLATE("linked");
const wxString gcstr::locations         =   wxTRANSLATE("Locations of sampled markers");
const wxString gcstr::locationsForRecom =wxTRANSLATE("Segment \"%s\" will need its locations item set if you wish to estimate recombination in Lamarc.\n\nDo you wish to continue your file export?");

const wxString gcstr::lociTabTitle      =   wxTRANSLATE("Properties of %d Segments");
const wxString gcstr::locus             =   wxTRANSLATE("contiguous segment");
const wxString gcstr::locusButtonAdd    =   wxTRANSLATE("Add");
const wxString gcstr::locusButtonMergeSelected    =   wxTRANSLATE("Merge Selected");
const wxString gcstr::locusButtonRemoveSelected    =   wxTRANSLATE("Remove Selected");
const wxString gcstr::locusCreate       =   wxTRANSLATE("Create new Segment");
const wxString gcstr::locusCreateTitle  =   wxTRANSLATE("Create new Segment");
const wxString gcstr::locusDialogMapPosition=   wxTRANSLATE("Map Position in Region:");
const wxString gcstr::locusEditString  =   wxTRANSLATE("Edit Segments");
const wxString gcstr::locusEnterNewName=   wxTRANSLATE("Enter the name of the new segment");
const wxString gcstr::locusExists       =   wxTRANSLATE("Segment \"%s\" already exists.");
const wxString gcstr::locusForAll      =   wxTRANSLATE("Set All Units to One Segment");
const wxString gcstr::locusLabelDataType   =   wxTRANSLATE("data type:%s");
const wxString gcstr::locusLabelLength     =   wxTRANSLATE("total length:%s");
const wxString gcstr::locusLabelLinked     =   wxTRANSLATE("sites linked:%s");
const wxString gcstr::locusLabelMapFile    =   wxTRANSLATE("Map Position File (optional)");
const wxString gcstr::locusLabelMapPosition=   wxTRANSLATE("position in region:%s");
const wxString gcstr::locusLabelName       =   wxTRANSLATE("name:%s");
const wxString gcstr::locusLabelOffset     =   wxTRANSLATE("Offset");
const wxString gcstr::locusLabelRegionName =   wxTRANSLATE("region:%s");
const wxString gcstr::locusLabelSites      =   wxTRANSLATE("# sites:%s");
const wxString gcstr::locusLength          =   wxTRANSLATE("Total Length");
const wxString gcstr::locusLengthIllegal   =   wxTRANSLATE("Illegal value \"%s\" for length of segment \"%s\". Ignoring.");
const wxString gcstr::locusLengthVsMarkers =   wxTRANSLATE("Segment length (%ld) must be > number of markers (%ld). Ignoring.");
const wxString gcstr::locusNameFromFile    =   wxTRANSLATE("segment %d of %s");
const wxString gcstr::locusNewName =    wxTRANSLATE("Name for New Segment");
const wxString gcstr::locusOffsetIllegal   =   wxTRANSLATE("Illegal value \"%s\" for length of segment \"%s\". Ignoring.");
const wxString gcstr::locusRename       =   wxTRANSLATE("Rename Segment");
const wxString gcstr::locusRenameChoice =   wxTRANSLATE("Segment to Rename");
const wxString gcstr::locusSelect       =   wxTRANSLATE("Select a Segment");
const wxString gcstr::locusMarkerCount  =   wxTRANSLATE("Number of Markers");
const wxString gcstr::locusUnlinked     =   wxTRANSLATE("unlinked markers");
const wxString gcstr::locusUse          =   wxTRANSLATE("Use this Segment");
const wxString gcstr::mapFileExportFailed   =   wxTRANSLATE("File export failed while reading data for region \"%s\". \n\nThe error was \"%s:%s\n\nPlease check your settings for that region and please report the error.");
const wxString gcstr::mapFileLastPositionTooLate =
    wxTRANSLATE("Map position file \"%s\" has last position of %ld, but region \"%s\" length (%ld) and first position sequenced (%ld) allow last position of %ld or less only");
const wxString gcstr::mapFileMarkerPositionMismatch =
    wxTRANSLATE("Map position file \"%s\" has %ld distinct positions, but region \"%s\" requires at least %ld");
const wxString gcstr::mapFileOffsetAfterFirstPosition =
    wxTRANSLATE("Map position file \"%s\" has first position %ld, which is before %ld, the start of sequencing in region \"%s\"");
const wxString gcstr::mapFileRegionMissing  =   wxTRANSLATE("Cannot export file because map position file \"%s\" has no data for region \"%s\"");
const wxString gcstr::mapFileSelect     =   wxTRANSLATE("select map position file");
const wxString gcstr::mapFileSelectAnother  =   wxTRANSLATE("file not listed here");
const wxString gcstr::mapFileUnSelect   =   wxTRANSLATE("un-select current file");
const wxString gcstr::mapFilesSelect    =   wxTRANSLATE("Select and apply file(s) with data sample spacing information.");
const wxString gcstr::mapPositionUnset  =   wxTRANSLATE("<unset map position>");
const wxString gcstr::mergeLinkGTitle        =   wxTRANSLATE("Combine Regions");
const wxString gcstr::mergeLinkGInstructions =   wxTRANSLATE("Merge with selected Regions:");
const wxString gcstr::mergeLociTitle        =   wxTRANSLATE("Combine Segments");
const wxString gcstr::mergeLociInstructions =   wxTRANSLATE("Merge with selected Segments:");
const wxString gcstr::mergePopsTitle        =   wxTRANSLATE("Combine Populations");
const wxString gcstr::mergePopsInstructions =   wxTRANSLATE("Merge with selected Populations:");
const wxString gcstr::microsat          =   "Microsat";
const wxString gcstr::migrate           =   "Migrate";
const wxString gcstr::moot              =   wxTRANSLATE("Moot");
const wxString gcstr::moveLocus         =   wxTRANSLATE("Moving segment %s out of region %s -- segments with unlinked data do not belong in multi-segment regions.");
const wxString gcstr::multiPhaseSample  =   wxTRANSLATE("induced by microsat/kallele file");
const wxString gcstr::nameCandidate     =   "%s_%d";
const wxString gcstr::nearRow           =   wxTRANSLATE("Near row %d: %s");
const wxString gcstr::newName           =   wxTRANSLATE("New name");
const wxString gcstr::no                =   "no";
const wxString gcstr::noChoice          =   wxTRANSLATE("No other objects to select");
const wxString gcstr::noChoiceLocus     =   wxTRANSLATE("No other segments to select");
const wxString gcstr::noChoicePopulation=   wxTRANSLATE("No other populations to select");
const wxString gcstr::noChoiceRegion    =   wxTRANSLATE("No other regions to select");
/*
const wxString gcstr::notebookLabelDataTab      =   wxTRANSLATE("Input Files");
const wxString gcstr::notebookLabelLocusTab     =   wxTRANSLATE("Properties of %d Segments");
const wxString gcstr::notebookLabelUnitTab      =   wxTRANSLATE("Population & Segment");
const wxString gcstr::notebookLabelRegionTab    =   wxTRANSLATE("Genomic Region Properties");
*/
const wxString gcstr::noWarningsFound   =   wxTRANSLATE("No warning messages were found. You should be able to export a lamarc file now");
const wxString gcstr::nuc               =   "Nucleotide";
const wxString gcstr::object            =   "object";
const wxString gcstr::parseAbort        =   wxTRANSLATE("Aborted    parse of %s(%s:%s,%s):%s");
const wxString gcstr::parseDataType     =   wxTRANSLATE("data type:%s");
const wxString gcstr::parseFormat       =   wxTRANSLATE("format:%s");
const wxString gcstr::parseGood         =   wxTRANSLATE("Successful parse of %s(%s:%s,%s)");
const wxString gcstr::parseInfo         =   wxTRANSLATE("Parsing Information from File:");
const wxString gcstr::parseInfoNone     =   wxTRANSLATE("Unable to parse file.\n\nPlease check you have a file in correct Phylip or Migrate format");
const wxString gcstr::parseInterleaving =   wxTRANSLATE("interleaving:%s");
const wxString gcstr::parseSettings     =   wxTRANSLATE("%s;%s;%s");
const wxString gcstr::parseSettingsForFile= wxTRANSLATE("%s parsed with %s");
const wxString gcstr::parseWarning      =   wxTRANSLATE("Conflict while parsing file");
const wxString gcstr::phaseFile         =   wxTRANSLATE("phase grouping set with phase resolution file");
const wxString gcstr::phenotype         =   wxTRANSLATE("phenotype");
const wxString gcstr::phylip            =   "Phylip";
const wxString gcstr::phylipNoKalleleMsat       =   wxTRANSLATE("Phylip format not compatible with Kallele or Microsat data (file \"%s\"");
const wxString gcstr::plainLong         =   "%ld";
const wxString gcstr::ploidy            =   "%ld-ploid";
const wxString gcstr::ploidy_1          =   wxTRANSLATE("haploid");
const wxString gcstr::ploidy_2          =   wxTRANSLATE("diploid");
const wxString gcstr::ploidy_3          =   wxTRANSLATE("triploid");
const wxString gcstr::ploidy_4          =   wxTRANSLATE("tetraploid");
const wxString gcstr::popEditButton     =   wxTRANSLATE("Edit");
const wxString gcstr::population        =   wxTRANSLATE("population");
const wxString gcstr::populationExists  =   wxTRANSLATE("Population \"%s\" already exists.");
const wxString gcstr::populationCreate  =   wxTRANSLATE("Create new Population");
const wxString gcstr::popButtonAdd    =   wxTRANSLATE("Add");
const wxString gcstr::popButtonMergeSelected    =   wxTRANSLATE("Merge Selected");
const wxString gcstr::popButtonRemoveSelected    =   wxTRANSLATE("Remove Selected");
const wxString gcstr::popCreateTitle    =   wxTRANSLATE("Create a New Population");
const wxString gcstr::popEnterNewName   =   wxTRANSLATE("New name:");
const wxString gcstr::popLabelName      =   wxTRANSLATE("name: %s");
const wxString gcstr::popTabTitle       =   wxTRANSLATE("Properties of %d Populations");
const wxString gcstr::populationNameFromFile    =   wxTRANSLATE("pop %d of %s");
const wxString gcstr::populationNewName =   wxTRANSLATE("Name for New Population");
const wxString gcstr::populationRename          =   wxTRANSLATE("Rename Population");
const wxString gcstr::populationRenameChoice    =   wxTRANSLATE("Population to Rename");
const wxString gcstr::populationSelect  =   wxTRANSLATE("Select a Population");
const wxString gcstr::populationUse     =   wxTRANSLATE("Use this Population");
const wxString gcstr::populationForAll  =   wxTRANSLATE("Set All Units to One Population");
const wxString gcstr::questionHeader    =   wxTRANSLATE("Warning: possible problem detected");
const wxString gcstr::region            =   wxTRANSLATE("region");
const wxString gcstr::regionChoice      =   wxTRANSLATE("Assign to Region:");
const wxString gcstr::regionCreate      =   wxTRANSLATE("Create new Region");
const wxString gcstr::regionEditString  =   wxTRANSLATE("Edit Genomic Regions");
const wxString gcstr::regionEffPopSize  =   wxTRANSLATE("Effective Population Size:");
const wxString gcstr::regionEnterNewName=   wxTRANSLATE("Enter the name of the new region");
const wxString gcstr::regionExists      =   wxTRANSLATE("Region \"%s\" already exists.");
const wxString gcstr::regionForAll      =   wxTRANSLATE("Set All Units to One Genomic Region");
const wxString gcstr::regionLabelDataType   =   wxTRANSLATE("Data Type");
const wxString gcstr::regionLabelEffPopSize =   wxTRANSLATE("effective population size:");
const wxString gcstr::regionLabelLength     =   wxTRANSLATE("Length");
const wxString gcstr::regionLabelMapFile    =   wxTRANSLATE("Map Position File (optional)");
const wxString gcstr::regionLabelMapPosition=   wxTRANSLATE("Map Position");
const wxString gcstr::regionLabelName       =   wxTRANSLATE("name: %s");
const wxString gcstr::regionLabelOffset     =   wxTRANSLATE("First Position Sequenced");
const wxString gcstr::regionLabelSamples    =   wxTRANSLATE("samples per individual:");
const wxString gcstr::regionLabelSites      =   wxTRANSLATE("Sites");
const wxString gcstr::regionLengthIllegal   =   wxTRANSLATE("Illegal value \"%s\" for length of region \"%s\". Ignoring.");
const wxString gcstr::regionLengthVsMarkers =   wxTRANSLATE("Region length (%ld) must be > number of markers (%ld). Ignoring.");
const wxString gcstr::regionNameFromFile    =   wxTRANSLATE("from %s");
const wxString gcstr::regionNameUnlinked    =   wxTRANSLATE("%s_%08ld");
const wxString gcstr::regionNewName     =   wxTRANSLATE("Name for New Region");
const wxString gcstr::regionOffsetIllegal   =   wxTRANSLATE("Illegal value \"%s\" for length of region \"%s\". Ignoring.");
const wxString gcstr::regionPositionInfo    =   wxTRANSLATE("Position info for segments:");
const wxString gcstr::regionRename      =   wxTRANSLATE("Rename Region");
const wxString gcstr::regionRenameChoice=   wxTRANSLATE("Region to Rename");
// const wxString gcstr::regionSamplesPer  =   wxTRANSLATE("Samples per Individual");
const wxString gcstr::regionSelect      =   wxTRANSLATE("Select a Region");
const wxString gcstr::regionUse         =   wxTRANSLATE("Use this Region");
const wxString gcstr::removeFiles       =   wxTRANSLATE("Remove Files");
const wxString gcstr::removeGroupsTitle        =   wxTRANSLATE("Remove Regions");
const wxString gcstr::removeGroupsInstructions =   wxTRANSLATE("Choose one or more");
const wxString gcstr::removeLociTitle        =   wxTRANSLATE("Remove Segments");
const wxString gcstr::removeLociInstructions =   wxTRANSLATE("Choose one or more");
const wxString gcstr::removePopsTitle        =   wxTRANSLATE("Remove Populations");
const wxString gcstr::removePopsInstructions =   wxTRANSLATE("Choose one or more");
const wxString gcstr::renameLinkGTitle  =   wxTRANSLATE("Rename a Region");
const wxString gcstr::renameLocusTitle  =   wxTRANSLATE("Rename Segment");
const wxString gcstr::renamePopTitle    =   wxTRANSLATE("Rename Population");
const wxString gcstr::renamePopTitleFor =   wxTRANSLATE("Rename Population %s");
const wxString gcstr::selectAll         =   wxTRANSLATE("Select All");
const wxString gcstr::sequential        =   wxTRANSLATE("Sequential");
const wxString gcstr::setDataTypesAll   =   wxTRANSLATE("Set Data Type for all Files");
const wxString gcstr::setFormats        =   wxTRANSLATE("Set Formats for Files");
const wxString gcstr::setInterleaving   =   wxTRANSLATE("Set Interleaving for Files");
const wxString gcstr::structureDump     =   wxTRANSLATE("%sStructures dump:");
// const wxString gcstr::tooFewSamplesPerIndividual    = wxTRANSLATE("Wanted %d samples per individual but got fewer");
// const wxString gcstr::tooManySamplesPerIndividual    = wxTRANSLATE("Wanted %d samples per individual but got more");
const wxString gcstr::trait             =   wxTRANSLATE("trait");
const wxString gcstr::traitEnterNewName=   wxTRANSLATE("Enter the name of the new trait class");
const wxString gcstr::trueVal           =   wxTRANSLATE("true");
const wxString gcstr::typeClashDialog   =   wxTRANSLATE("File \"%s\" specifies data type \"%s\", but you have specified \"%s\".\n\nPlease specify which one you want.");
const wxString gcstr::unselectAll       =   wxTRANSLATE("Unselect All");
const wxString gcstr::unsetValueLocations       =   wxTRANSLATE("<enter an ordered list of integers>");
const wxString gcstr::unsetValueLocusLength     =   wxTRANSLATE("<enter a positive integer>");
const wxString gcstr::unsetValueLocusPosition   =   wxTRANSLATE("<enter an integer>");
const wxString gcstr::unsetValueOffset          =   wxTRANSLATE("<enter an integer>");
const wxString gcstr::unsetValueRegionEffectivePopulationSize   =   wxTRANSLATE("<enter a positive number>");
const wxString gcstr::unsetValueRegionSamples   =   wxTRANSLATE("<enter a positive integer>");
const wxString gcstr::snp                       =   "SNP";
const wxString gcstr::warning                   =   wxTRANSLATE("Warning");
const wxString gcstr::warningMissingPopRegPair  =   wxTRANSLATE("Missing data sample covering (%s,%s) pair");
const wxString gcstr::warningNeedFile           =   wxTRANSLATE("Add one or more files");
const wxString gcstr::warningNeedFileDataType   =   wxTRANSLATE("File \"%s\" needs its data type set");
const wxString gcstr::warningNeedFileDataTypes  =   wxTRANSLATE("At least one file needs its data type set");
const wxString gcstr::warningNeedFileFormat     =   wxTRANSLATE("File \"%s\" needs its file format set");
const wxString gcstr::warningNeedFileFormats    =   wxTRANSLATE("At least one file needs its file format set");
const wxString gcstr::warningNeedFilesParsed    =   wxTRANSLATE("At least one file has not been parsed.");
const wxString gcstr::warningStringsHeader      =   wxTRANSLATE("You will need to fix the following things before you can create a Lamarc output file:");
const wxString gcstr::warningUnsetLinkageGroup  =   wxTRANSLATE("At least one data unit has no region assigned");
const wxString gcstr::warningUnsetLocus         =   wxTRANSLATE("At least one data unit has no segment assigned");
const wxString gcstr::warningUnsetPopulation    =   wxTRANSLATE("At least one data unit has no population assigned");
const wxString gcstr::warningUnsetRegion        =   wxTRANSLATE("At least one data unit has no region assigned");
const wxString gcstr::unknown                   =      "???";
const wxString gcstr::unrecognizedFileFormat    =   wxTRANSLATE("Did not recognize file format \"%s\". Setting to \"none\"");
const wxString gcstr::usageHeader               =   wxTRANSLATE("**********************************************************************\nInput File Conversion Program for LAMARC Version %s\n**********************************************************************");
const wxString gcstr::userTypeOverride          =   wxTRANSLATE("Overriding type %s in file %s to user-specified choice of %s");
const wxString gcstr::xmlFiles                  =   "XML Files (*.xml)|*.xml|All Files (*)|*";
const wxString gcstr::yes                       =   "yes";


const wxString gcstr::cmdBatch                   =   "batchonly";
const wxString gcstr::cmdBatchChar               =   "b";
const wxString gcstr::cmdBatchDescription        =   wxTRANSLATE("run in batch mode and exit immediately.");
const wxString gcstr::cmdCommand                 =   "commandfile";
const wxString gcstr::cmdCommandChar             =   "c";
const wxString gcstr::cmdCommandDescription      =   wxTRANSLATE("command file for batch run; see documentation");
const wxString gcstr::cmdDump                    =   "dump";
const wxString gcstr::cmdDumpChar                =   "d";
const wxString gcstr::cmdDumpDescription         =   wxTRANSLATE("do debug dump just before exiting");
const wxString gcstr::cmdFileFormat              =   "format";
const wxString gcstr::cmdFileFormatChar          =   "f";
const wxString gcstr::cmdFileFormatDescription   =   wxTRANSLATE("input file format (MIGRATE or PHYLIP)");
const wxString gcstr::cmdInput                   =   "inputfile";
const wxString gcstr::cmdInputChar               =   "i";
const wxString gcstr::cmdInputDescription        =   wxTRANSLATE("input file");
const wxString gcstr::cmdInterleaved             =   "interleaved";
const wxString gcstr::cmdInterleavedChar         =   "n";
const wxString gcstr::cmdInterleavedDescription  =   wxTRANSLATE("input file is in interleaved format");
const wxString gcstr::cmdMapFile                 =   "mapfile";
const wxString gcstr::cmdMapFileChar             =   "m";
const wxString gcstr::cmdMapFileDescription      =   wxTRANSLATE("map file");
const wxString gcstr::cmdOutput                  =   "outputfile";
const wxString gcstr::cmdOutputChar              =   "o";
const wxString gcstr::cmdOutputDescription       =   wxTRANSLATE("output file; default is \"%s\"");
const wxString gcstr::cmdWriteBatch              =   "writebatch";
const wxString gcstr::cmdWriteBatchChar          =   "w";
const wxString gcstr::cmdWriteBatchDescription   =   wxTRANSLATE("write batch file for data state at end of run");


const wxString gcverbose::addedFile             = wxTRANSLATE("Added file \"%s\"");
const wxString gcverbose::addedLocus            = wxTRANSLATE("Added segment \"%s\"");
const wxString gcverbose::addedPopulation       = wxTRANSLATE("Added population \"%s\"");
const wxString gcverbose::addedRegion           = wxTRANSLATE("Added region \"%s\"");
const wxString gcverbose::addedUnit             = wxTRANSLATE("Added unit \"%s\"");
const wxString gcverbose::exportSuccess         = wxTRANSLATE("Successful export to file \"%s\"");
const wxString gcverbose::exportTry             = wxTRANSLATE("Attempting export to file \"%s\"");
const wxString gcverbose::firstPositionNotLong  = wxTRANSLATE("Ignoring first scanned position of \"%s\" for segment \"%s\". It should have been an integer.");
const wxString gcverbose::locationsNotIntegers  = wxTRANSLATE("Ignoring locations of \"%s\" for segment \"%s\". It should have been an ordered list of integers.");
const wxString gcverbose::locusLengthNotLong    = wxTRANSLATE("Ignoring length of \"%s\" for segment \"%s\". It should have been a positive integer.");
const wxString gcverbose::locusPositionNotLong  = wxTRANSLATE("Ignoring starting position of \"%s\" for segment \"%s\".  It should have been an integer.");
const wxString gcverbose::noSetDataType         = wxTRANSLATE("Failed to set data type of file \"%s\" to \"%s\"");
const wxString gcverbose::noSetFileFormat       = wxTRANSLATE("Failed to set format of file \"%s\" to \"%s\"");
const wxString gcverbose::noSetIsInterleaved    = wxTRANSLATE("Failed to set interleaving of file \"%s\" to \"%s\"");
//const wxString gcverbose::noSetIsUnlinked       = wxTRANSLATE("Failed to set unlinking of file \"%s\" to \"%s\"");
const wxString gcverbose::parseAttemptExiting   = wxTRANSLATE("Exiting call to parse file \"%s\"");
const wxString gcverbose::parseAttemptFailed    = wxTRANSLATE("Failed to parse file \"%s\"");
const wxString gcverbose::parseAttemptPossible  = wxTRANSLATE("Entering call to parse file \"%s\"");
const wxString gcverbose::parseAttemptSettings  = wxTRANSLATE("Setting values following parse file \"%s\"");
const wxString gcverbose::parseAttemptStarted   = wxTRANSLATE("Starting to parse file \"%s\"");
const wxString gcverbose::parseAttemptSuccessful= wxTRANSLATE("Succeeded parsing file \"%s\"");
const wxString gcverbose::removedFile           = wxTRANSLATE("Removed file \"%s\"");
const wxString gcverbose::removedLocus          = wxTRANSLATE("Removed segment \"%s\"");
const wxString gcverbose::removedPopulation     = wxTRANSLATE("Removed population \"%s\"");
const wxString gcverbose::removedRegion         = wxTRANSLATE("Removed region \"%s\"");
const wxString gcverbose::removedUnit           = wxTRANSLATE("Removed unit \"%s\"");
const wxString gcverbose::setDataType           = wxTRANSLATE("Set data type of file \"%s\" to \"%s\"");
const wxString gcverbose::setDataTypeAndFileFormat  = wxTRANSLATE("Set data type of file \"%s\" to \"%s\" and therefore file format to \"%s\"");
const wxString gcverbose::setFileFormat         = wxTRANSLATE("Set format of file \"%s\" to \"%s\"");
const wxString gcverbose::setIsInterleaved      = wxTRANSLATE("Set interleaving of file \"%s\" to \"%s\"");
//const wxString gcverbose::setIsUnlinked         = wxTRANSLATE("Set unlinking of file \"%s\" to \"%s\"");
